package com.xyh.mychatgpt.controller;
import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.unfbx.chatgpt.entity.chat.ChatCompletion;
import com.xyh.mychatgpt.utils.ChatGPTUtils;
import com.xyh.mychatgpt.utils.R;
import com.xyh.mychatgpt.utils.RedisUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;


/**
 * @author xiangyuanhong
 * @description: TODO
 * @date 2023/2/28下午4:57
 */
@RestController
public class IndexController {
    @Autowired
    private RedisUtils redisUtils;
    @Autowired
    private ChatGPTUtils chatGPTUtils;

    @GetMapping("/ask")
    public R ask(String question,HttpServletRequest request) {
        String uuid=IdUtil.simpleUUID();
        if (StrUtil.isBlank(question)) {
            question = "今天天气怎么样？";
        }
        String finalQuestion = question;
        ThreadUtil.execAsync(()->{
            chatGPTUtils.ask(ChatCompletion.Model.GPT_3_5_TURBO.getName(), finalQuestion,uuid);
//            chatGPTUtils.ask(ChatCompletion.Model.GPT_4_32K.getName(), finalQuestion,uuid);
        });
        return R.ok().put("data",uuid);
    }

    @GetMapping("/answer")
    public R answer(String uuid){
        String result=redisUtils.get(uuid);
          return R.ok().put("data",result);
    }


    public void test(){
        chatGPTUtils.askForStream();
    }

    /**
     * 查询账号金额信息
     * @return
     */
    @GetMapping("/creditGrants")
    public R creditGrants(){

        Map<String,Object> result = chatGPTUtils.creditGrants();

        return R.ok().put("data",result);
    }

}
