package com.xyh.mychatgpt.service.impl;

import cn.hutool.core.date.DateUtil;
import com.xyh.mychatgpt.utils.PageUtils;
import com.xyh.mychatgpt.utils.RedisUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.transaction.annotation.Transactional;
import com.xyh.mychatgpt.dao.ChatQuestionDao;
import com.xyh.mychatgpt.entity.ChatQuestionEntity;
import com.xyh.mychatgpt.service.ChatQuestionService;

/**
 * chat管理模块
 *
 * @author xiangyuanhong
 * @email xiangyuanhong08@163.com
 * @date 2023-03-20 17:16:47
 */
@Transactional
@Service("chatQuestionService")
public class ChatQuestionServiceImpl extends ServiceImpl<ChatQuestionDao, ChatQuestionEntity> implements ChatQuestionService {

    @Autowired
    private RedisUtils redisUtils;

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        int pageIndex=params.get("page")==null ?1:Integer.parseInt(params.get("page").toString());
        int pageSize=params.get("limit")==null?10:Integer.parseInt(params.get("limit").toString());
        MPJLambdaWrapper<ChatQuestionEntity> queryWrapper=new MPJLambdaWrapper<ChatQuestionEntity>();
        IPage<ChatQuestionEntity> page = baseMapper.selectJoinPage(new Page<>(pageIndex,pageSize),ChatQuestionEntity.class,queryWrapper);
        return new PageUtils(page);
    }

    @Override
    public List<ChatQuestionEntity> queryList(Map<String, Object> params){

        MPJLambdaWrapper<ChatQuestionEntity> queryWrapper=new MPJLambdaWrapper<ChatQuestionEntity>();

        return this.baseMapper.selectJoinList(ChatQuestionEntity.class,queryWrapper);
    }


    @Override
    public boolean deleteBatch(Long[] ids){
        UpdateWrapper<ChatQuestionEntity> updateWrapper=new UpdateWrapper<>();

        updateWrapper.set("deleted",0);

        updateWrapper.in("id",ids);

        return update(updateWrapper);
    }

    @Override
    public boolean save(ChatQuestionEntity entity) {
        redisUtils.leftPush(entity.getSessionId(),entity);
        entity.setCreateTime(DateUtil.date());
        return this.save(entity);
    }

    @Override
    public boolean update(ChatQuestionEntity entity) {
        entity.setUpdateTime(DateUtil.date());
        return this.updateById(entity);
    }

}